/* ************************************************************************* *
 *                                                                           *
 *    rpc_defaults.h,v
 *    RPC default values
 *                                                                           *
 *    Copyright (C) 1995 A. Bode, S. Lamberts, T. Ludwig, C. R"oder          *
 *                                                                           *
 *    PFSLib (Parallel I/O on workstations)                                  *
 *                                                                           *
 *    PFSLib offers parallel access to files for a parallel application      *
 *    running on a cluster of workstations.                                  *
 *    It is intended but not restricted to be used in message passing        *
 *    applications based on PVM, NXLib, MPI, and other.                      *
 *                                                                           *
 *    PFSLib consists of a LIBRARY, deamon PROGRAMS, and utility PROGRAMS.   *
 *                                                                           *
 *    PFSLib is free software; you can redistribute the LIBRARY and/or       *
 *    modify it under the terms of the GNU Library General Public            *
 *    License as published by the Free Software Foundation; either           *
 *    version 2 of the License, or (at your option) any later version.       *
 *    You can redistribute the daemon PROGRAMS and utility PROGRAMS          *
 *    and/or modify them under the terms of the GNU General Public           *
 *    License as published by the Free Software Foundation; either           *
 *    version 2 of the License, or (at your option) any later version.       *
 *                                                                           *
 *    PFSLib is distributed in the hope that it will be useful,              *
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of         *
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU      *
 *    Library General Public License and GNU General Public License          *
 *    for more details.                                                      *
 *                                                                           *
 *    You should have received a copy of the GNU Library General Public      *
 *    License and the GNU General Public License along with this             *
 *    library; if not, write to the Free                                     *
 *    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.     *
 *                                                                           *
 *    Contact to the authors:                                                *
 *                                                                           *
 *    electronic mail: pfslib@informatik.tu-muenchen.de                      *
 *                                                                           *
 *    paper mail:      Prof. Dr. A. Bode                                     *
 *                     Lehrstuhl f"ur Rechnertechnik und                     *
 *                     Rechnerorganisation                                   *
 *                     Institut f"ur Informatik                              *
 *                     Technische Universit"at M"unchen                      *
 *                     80290 M"unchen                                        *
 *                     Germany                                               *
 *                                                                           *
 *    This project was partially funded by a research grant form Intel       *
 *    Corporation.                                                           *
 *                                                                           *
 * ************************************************************************* */


/* ************************************************************************* *
 *                                                                           *
 *  RCS Filename : rpc_defaults.h,v
 *  RCS Date     : 1996/05/28 15:54:41
 *  RCS Revision : 1.2
 *  RCS Author   : lamberts
 *  RCS State    : V2_0_B
 *                                                                           *
 *  Authors: Stefan Lamberts, Christian R"oder                               *
 *                                                                           *
 * ************************************************************************* */
#ifndef __pfslib_timeouts_h_
#define __pfslib_timeouts_h_

#ifndef lint
static void *rcs_id_timeouts_h = "rpc_defaults.h,v 1.2 1996/05/28 15:54:41 lamberts V2_0_B";
#endif

/* ************************************************************************* *
 * Definitions for RPC calls.                                                *
 * ************************************************************************* */
#define RPC_UDP_TIMEOUT  60     /* Resend timeout for UDP in seconds */

#define DFLTTIMEOUT 10000       /* default timeout for RPC (25sec) */

#define AWAITTIMEOUT (24*3600)  /* when synchronising set long timeout
                                   for the client (24h) */

#define CLNT_TCP_CREATE_RETRIES 5 /* Numer of retries to create a tcp
                                     client handle */

#ifdef RS6K
#define RPC_TCP_BUFSZ    65536
#else  /* RS6K */
#define RPC_TCP_BUFSZ    32768
#endif /* RS6K */

#define CONNECT_RETRIES 5

#ifdef LOCAL_ATM_IF

#define ATM_NAME_EXT ".atm"

#endif /* MYATMHACK */

#endif /* __pfslib_timeouts_h_ */
