/*
 * Please do not edit this file.
 * It was generated using rpcgen.
 */

#include <rpc/types.h>

/* ************************************************************************* *
 *                                                                           *
 *    iod.x,v
 *    RPC description file for the iod program
 *                                                                           *
 *    Copyright (C) 1995 A. Bode, S. Lamberts, T. Ludwig, C. R"oder          *
 *                                                                           *
 *    PFSLib (Parallel I/O on workstations)                                  *
 *                                                                           *
 *    PFSLib offers parallel access to files for a parallel application      *
 *    running on a cluster of workstations.                                  *
 *    It is intended but not restricted to be used in message passing        *
 *    applications based on PVM, NXLib, MPI, and other.                      *
 *                                                                           *
 *    PFSLib consists of a LIBRARY, deamon PROGRAMS, and utility PROGRAMS.   *
 *                                                                           *
 *    PFSLib is free software; you can redistribute the LIBRARY and/or       *
 *    modify it under the terms of the GNU Library General Public            *
 *    License as published by the Free Software Foundation; either           *
 *    version 2 of the License, or (at your option) any later version.       *
 *    You can redistribute the daemon PROGRAMS and utility PROGRAMS          *
 *    and/or modify them under the terms of the GNU General Public           *
 *    License as published by the Free Software Foundation; either           *
 *    version 2 of the License, or (at your option) any later version.       *
 *                                                                           *
 *    PFSLib is distributed in the hope that it will be useful,              *
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of         *
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU      *
 *    Library General Public License and GNU General Public License          *
 *    for more details.                                                      *
 *                                                                           *
 *    You should have received a copy of the GNU Library General Public      *
 *    License and the GNU General Public License along with this             *
 *    library; if not, write to the Free                                     *
 *    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.     *
 *                                                                           *
 *    Contact to the authors:                                                *
 *                                                                           *
 *    electronic mail: pfslib@informatik.tu-muenchen.de                      *
 *                                                                           *
 *    paper mail:      Prof. Dr. A. Bode                                     *
 *                     Lehrstuhl f"ur Rechnertechnik und                     *
 *                     Rechnerorganisation                                   *
 *                     Institut f"ur Informatik                              *
 *                     Technische Universit"at M"unchen                      *
 *                     80290 M"unchen                                        *
 *                     Germany                                               *
 *                                                                           *
 *    This project was partially funded by a research grant form Intel       *
 *    Corporation.                                                           *
 *                                                                           *
 * ************************************************************************* */


/* ************************************************************************* *
 *                                                                           *
 *  RCS Filename : iod.x,v
 *  RCS Date     : 1996/05/28 16:04:06
 *  RCS Revision : 1.4
 *  RCS Author   : lamberts
 *  RCS State    : V2_0_B
 *                                                                           *
 *  Authors: Stefan Lamberts, Christian R"oder                               *
 *                                                                           *
 * ************************************************************************* */
#ifndef lint
#ifndef __rcs_id_iod_x__
#define __rcs_id_iod_x__
static void *rcs_id_iod_x = "iod.x,v 1.4 1996/05/28 16:04:06 lamberts V2_0_B";
#endif
#endif


#ifndef lint
#ifndef __rcs_id_global_rcp_h__
#define  __rcs_id_global_rcp_h__
static void *rcs_id_global_rpc_h = "global_rpc.h,v 1.1 1996/04/24 14:28:00 lamberts V2_0_B";
#endif
#endif



#ifdef HPPA
#include <sys/time.h>
#include <sys/types.h>
#endif /* HPPA */

#ifdef SUN4
#include <memory.h>
#else
#include <string.h>
#endif /* SUN4 */


#include "global.h"


#define bzero(a,b) memset(a,0,b)


#define ERR_MACRO(a,b)\
result.stat = RPC_ERR;\
result.a.err.errno = b;\
result.a.err.errstr = pfslib_geterrstr(b);

/* Flags for open() call */
bool_t xdr_pfslib_otype();


struct errorinfo {
	int errno;
	char *errstr;
};
typedef struct errorinfo errorinfo;
bool_t xdr_errorinfo();

typedef struct {
	u_int iod_filedata_len;
	char *iod_filedata_val;
} iod_filedata;
bool_t xdr_iod_filedata();

struct iod_ioopargs {
	char *fn;
	pfslib_otype oflags;
	int perm;
	long offset;
	long length;
	long thresh;
	iod_filedata data;
};
typedef struct iod_ioopargs iod_ioopargs;
bool_t xdr_iod_ioopargs();

struct iod_truncargs {
	char *fn;
	long offset;
};
typedef struct iod_truncargs iod_truncargs;
bool_t xdr_iod_truncargs();

struct iod_unlinkargs {
	char *fn;
};
typedef struct iod_unlinkargs iod_unlinkargs;
bool_t xdr_iod_unlinkargs();

struct iod_opres {
	long length;
	iod_filedata data;
};
typedef struct iod_opres iod_opres;
bool_t xdr_iod_opres();

struct iod_ioopres {
	int stat;
	union {
		iod_opres res;
		errorinfo err;
	} iod_ioopres_u;
};
typedef struct iod_ioopres iod_ioopres;
bool_t xdr_iod_ioopres();

struct iod_errorres {
	int stat;
	union {
		errorinfo err;
	} iod_errorres_u;
};
typedef struct iod_errorres iod_errorres;
bool_t xdr_iod_errorres();

#define IOD ((u_long)0x399999)
extern struct rpcgen_table iod_1_table[];
extern iod_1_nproc;
#define IOD_VERS ((u_long)1)
#define IOD_EXIT ((u_long)1)
extern void *iod_exit_1();
#define IOD_READ ((u_long)2)
extern iod_ioopres *iod_read_1();
#define IOD_WRITE ((u_long)3)
extern iod_ioopres *iod_write_1();
#define IOD_TRUNC ((u_long)4)
extern iod_errorres *iod_trunc_1();
#define IOD_UNLINK ((u_long)5)
extern iod_errorres *iod_unlink_1();
struct rpcgen_table {
    char	*(*proc)();
    xdrproc_t	xdr_arg;
    unsigned	len_arg;
    xdrproc_t	xdr_res;
    unsigned	len_res;
};
