/*
 * Please do not edit this file.
 * It was generated using rpcgen.
 */

#include <rpc/types.h>

/* ************************************************************************* *
 *                                                                           *
 *    pfsd.x,v
 *    RPC description file for the pfsd program
 *                                                                           *
 *    Copyright (C) 1995 A. Bode, S. Lamberts, T. Ludwig, C. R"oder          *
 *                                                                           *
 *    PFSLib (Parallel I/O on workstations)                                  *
 *                                                                           *
 *    PFSLib offers parallel access to files for a parallel application      *
 *    running on a cluster of workstations.                                  *
 *    It is intended but not restricted to be used in message passing        *
 *    applications based on PVM, NXLib, MPI, and other.                      *
 *                                                                           *
 *    PFSLib consists of a LIBRARY, deamon PROGRAMS, and utility PROGRAMS.   *
 *                                                                           *
 *    PFSLib is free software; you can redistribute the LIBRARY and/or       *
 *    modify it under the terms of the GNU Library General Public            *
 *    License as published by the Free Software Foundation; either           *
 *    version 2 of the License, or (at your option) any later version.       *
 *    You can redistribute the daemon PROGRAMS and utility PROGRAMS          *
 *    and/or modify them under the terms of the GNU General Public           *
 *    License as published by the Free Software Foundation; either           *
 *    version 2 of the License, or (at your option) any later version.       *
 *                                                                           *
 *    PFSLib is distributed in the hope that it will be useful,              *
 *    but WITHOUT ANY WARRANTY; without even the implied warranty of         *
 *    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU      *
 *    Library General Public License and GNU General Public License          *
 *    for more details.                                                      *
 *                                                                           *
 *    You should have received a copy of the GNU Library General Public      *
 *    License and the GNU General Public License along with this             *
 *    library; if not, write to the Free                                     *
 *    Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.     *
 *                                                                           *
 *    Contact to the authors:                                                *
 *                                                                           *
 *    electronic mail: pfslib@informatik.tu-muenchen.de                      *
 *                                                                           *
 *    paper mail:      Prof. Dr. A. Bode                                     *
 *                     Lehrstuhl f"ur Rechnertechnik und                     *
 *                     Rechnerorganisation                                   *
 *                     Institut f"ur Informatik                              *
 *                     Technische Universit"at M"unchen                      *
 *                     80290 M"unchen                                        *
 *                     Germany                                               *
 *                                                                           *
 *    This project was partially funded by a research grant form Intel       *
 *    Corporation.                                                           *
 *                                                                           *
 * ************************************************************************* */


/* ************************************************************************* *
 *                                                                           *
 *  RCS Filename : pfsd.x,v
 *  RCS Date     : 1996/12/27 15:46:56
 *  RCS Revision : 1.3
 *  RCS Author   : lamberts
 *  RCS State    : V2_0_B
 *                                                                           *
 *  Authors: Stefan Lamberts, Christian R"oder                               *
 *                                                                           *
 * ************************************************************************* */
#ifndef lint
#ifndef __rcs_id_pfsd_x__
#define __rcs_id_pfsd_x__
static void *rcs_id_pfsd_x = "pfsd.x,v 1.3 1996/12/27 15:46:56 lamberts V2_0_B";
#endif
#endif


#ifndef lint
#ifndef __rcs_id_global_rcp_h__
#define  __rcs_id_global_rcp_h__
static void *rcs_id_global_rpc_h = "global_rpc.h,v 1.1 1996/04/24 14:28:00 lamberts V2_0_B";
#endif
#endif



#ifdef HPPA
#include <sys/time.h>
#include <sys/types.h>
#endif /* HPPA */

#ifdef SUN4
#include <memory.h>
#else
#include <string.h>
#endif /* SUN4 */


#include "global.h"


#define bzero(a,b) memset(a,0,b)


#define ERR_MACRO(a,b)\
result.stat = RPC_ERR;\
result.a.err.errno = b;\
result.a.err.errstr = pfslib_geterrstr(b);

/* Flags for open() call */
bool_t xdr_pfslib_otype();


struct errorinfo {
	int errno;
	char *errstr;
};
typedef struct errorinfo errorinfo;
bool_t xdr_errorinfo();

struct pfslib_fhdl {
	int vfd;
	int how_many;
	int which;
	int mode;
	int pid;
};
typedef struct pfslib_fhdl pfslib_fhdl;
bool_t xdr_pfslib_fhdl();

struct pfslib_fattr {
	int type;
	int amode;
	int nlink;
	int userid;
	int groupid;
	long size;
	long atime;
	long mtime;
	long ctime;
	int actual;
};
typedef struct pfslib_fattr pfslib_fattr;
bool_t xdr_pfslib_fattr();

struct openargs {
	bool_t global;
	char *filename;
	pfslib_otype oflags;
	int permission;
	int how_many;
	int which;
	int mode;
	int pid;
};
typedef struct openargs openargs;
bool_t xdr_openargs();

struct setiomodeargs {
	pfslib_fhdl fh;
	int mode;
};
typedef struct setiomodeargs setiomodeargs;
bool_t xdr_setiomodeargs();

struct getioidargs {
	pfslib_fhdl fh;
	int op;
	long iolen;
};
typedef struct getioidargs getioidargs;
bool_t xdr_getioidargs();

struct ioidstatargs {
	pfslib_fhdl fh;
	int ioID;
};
typedef struct ioidstatargs ioidstatargs;
bool_t xdr_ioidstatargs();

struct fpmoveargs {
	pfslib_fhdl fh;
	int whence;
	long offset;
};
typedef struct fpmoveargs fpmoveargs;
bool_t xdr_fpmoveargs();

struct resetargs {
	char *fname;
};
typedef struct resetargs resetargs;
bool_t xdr_resetargs();

struct prtstatargs {
	bool_t verbose;
	bool_t iods;
	char *fname;
};
typedef struct prtstatargs prtstatargs;
bool_t xdr_prtstatargs();

struct ioopdoneargs {
	pfslib_fhdl fh;
	int ioID;
	long res;
	int errno;
};
typedef struct ioopdoneargs ioopdoneargs;
bool_t xdr_ioopdoneargs();

struct openres {
	int stat;
	union {
		pfslib_fhdl fh;
		errorinfo err;
	} openres_u;
};
typedef struct openres openres;
bool_t xdr_openres();

struct iomoderes {
	int stat;
	union {
		int mode;
		errorinfo err;
	} iomoderes_u;
};
typedef struct iomoderes iomoderes;
bool_t xdr_iomoderes();

struct getioidres {
	int stat;
	union {
		int ioID;
		errorinfo err;
	} getioidres_u;
};
typedef struct getioidres getioidres;
bool_t xdr_getioidres();

struct ioopresult {
	bool_t done;
	long res;
	int errno;
};
typedef struct ioopresult ioopresult;
bool_t xdr_ioopresult();

struct ioopres {
	int stat;
	union {
		ioopresult res;
		errorinfo err;
	} ioopres_u;
};
typedef struct ioopres ioopres;
bool_t xdr_ioopres();

struct DIST_LIST_EL {
	char ipaddr[IPADDRLEN];
	char filename[MAXNLEN];
	long offset;
	long length;
	bool_t done;
};
typedef struct DIST_LIST_EL DIST_LIST_EL;
bool_t xdr_DIST_LIST_EL();

typedef struct {
	u_int DIST_LIST_len;
	DIST_LIST_EL *DIST_LIST_val;
} DIST_LIST;
bool_t xdr_DIST_LIST();

struct DIST_RESULT {
	DIST_LIST list;
	pfslib_otype oflags;
	int perm;
};
typedef struct DIST_RESULT DIST_RESULT;
bool_t xdr_DIST_RESULT();

struct getdistres {
	int stat;
	union {
		DIST_RESULT res;
		errorinfo err;
	} getdistres_u;
};
typedef struct getdistres getdistres;
bool_t xdr_getdistres();

struct lsizeres {
	int stat;
	union {
		long size;
		errorinfo err;
	} lsizeres_u;
};
typedef struct lsizeres lsizeres;
bool_t xdr_lsizeres();

struct iseofres {
	int stat;
	union {
		bool_t eof;
		errorinfo err;
	} iseofres_u;
};
typedef struct iseofres iseofres;
bool_t xdr_iseofres();

struct lseekres {
	int stat;
	union {
		long pos;
		errorinfo err;
	} lseekres_u;
};
typedef struct lseekres lseekres;
bool_t xdr_lseekres();

struct fattrres {
	int stat;
	union {
		pfslib_fattr attr;
		errorinfo err;
	} fattrres_u;
};
typedef struct fattrres fattrres;
bool_t xdr_fattrres();

struct errorres {
	int stat;
	union {
		errorinfo err;
	} errorres_u;
};
typedef struct errorres errorres;
bool_t xdr_errorres();

struct resetres {
	int stat;
	union {
		int count;
		errorinfo err;
	} resetres_u;
};
typedef struct resetres resetres;
bool_t xdr_resetres();

#define PFSD ((u_long)0x399997)
extern struct rpcgen_table pfsd_1_table[];
extern pfsd_1_nproc;
#define PFSD_VERS ((u_long)1)
#define PFSD_OPEN ((u_long)1)
extern openres *pfsd_open_1();
#define PFSD_SETIOMODE ((u_long)2)
extern errorres *pfsd_setiomode_1();
#define PFSD_GETIOMODE ((u_long)3)
extern iomoderes *pfsd_getiomode_1();
#define PFSD_GETIOID ((u_long)4)
extern getioidres *pfsd_getioid_1();
#define PFSD_IODONE ((u_long)5)
extern ioopres *pfsd_iodone_1();
#define PFSD_IOWAIT ((u_long)6)
extern ioopres *pfsd_iowait_1();
#define PFSD_LSIZE ((u_long)8)
extern lsizeres *pfsd_lsize_1();
#define PFSD_ISEOF ((u_long)9)
extern iseofres *pfsd_iseof_1();
#define PFSD_LSEEK ((u_long)10)
extern lseekres *pfsd_lseek_1();
#define PFSD_GETFATTR ((u_long)11)
extern fattrres *pfsd_getfattr_1();
#define PFSD_CLOSE ((u_long)12)
extern errorres *pfsd_close_1();
#define PFSD_NUMCLNTS ((u_long)13)
extern int *pfsd_numclnts_1();
#define PFSD_NUMFILES ((u_long)14)
extern int *pfsd_numfiles_1();
#define PFSD_RESET ((u_long)15)
extern resetres *pfsd_reset_1();
#define PFSD_CLTEXIT ((u_long)16)
extern void *pfsd_cltexit_1();
#define PFSD_PRTSTAT ((u_long)17)
extern void *pfsd_prtstat_1();
#define PFSD_EXIT ((u_long)18)
extern void *pfsd_exit_1();
#define PFSD_GETDIST ((u_long)19)
extern getdistres *pfsd_getdist_1();
#define PFSD_IOOPDONE ((u_long)20)
extern errorres *pfsd_ioopdone_1();
#define PFSD_UNLINK ((u_long)30)
extern errorres *pfsd_unlink_1();
struct rpcgen_table {
    char	*(*proc)();
    xdrproc_t	xdr_arg;
    unsigned	len_arg;
    xdrproc_t	xdr_res;
    unsigned	len_res;
};
